# ECharts

<a href="http://echarts.baidu.com">
    <img style="vertical-align: top;" src="./asset/logo.png?raw=true" alt="logo" height="50px">
</a>

[![NPM version][npm-badge]][npm] [![Build Status][travis-ci-image]][travis-ci-url]

[![Dependency Status][deps-badge]][deps]
[![devDependency Status][dev-deps-badge]][dev-deps]
[![peerDependency Status][peer-deps-badge]][peer-deps]

## Introduction

ECharts is a free, powerful charting and visualization library offering an easy way of adding intuitive, interactive, and highly customizable charts to your commercial products. It is written in pure JavaScript and based on [zrender](https://github.com/luqin/zrender), which is a whole new lightweight canvas library.

## Installation

**[npm](https://www.npmjs.com/)/[webpack](https://github.com/webpack/webpack)**

```sh
$ npm i echarts --save
```

```js
import echarts from 'echarts';
import 'echarts/chart/bar';
import 'echarts/chart/pie';

let mychart = echarts.init(dom, null, { renderer: 'canvas' });
mychart.setOption({ ... });
```

or

```
import echarts from 'echarts/dist/echarts'; // or echarts.common or echarts.simple

let mychart = echarts.init(dom, null, { renderer: 'canvas' });
mychart.setOption({ ... });
```

Examples: [echarts-webpack-starter-kit](https://github.com/luqin/echarts-webpack-starter-kit)



## Docs

+ [Tutorial](http://echarts.baidu.com/tutorial.html)
+ [API](http://echarts.baidu.com/api.html)
+ [Option Manual](http://echarts.baidu.com/option.html)

## License
Copyright (c) 2013, Baidu Inc.
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those
of the authors and should not be interpreted as representing official policies,
either expressed or implied, of the FreeBSD Project.


[npm-badge]: http://badge.fury.io/js/echarts.svg
[npm]: https://www.npmjs.com/package/echarts

[deps-badge]: https://david-dm.org/luqin/echarts.svg
[deps]: https://david-dm.org/luqin/echarts

[dev-deps-badge]: https://david-dm.org/luqin/echarts/dev-status.svg
[dev-deps]: https://david-dm.org/luqin/echarts#info=devDependencies

[peer-deps-badge]: https://david-dm.org/luqin/echarts/peer-status.svg
[peer-deps]: https://david-dm.org/luqin/echarts#info=peerDependencies 

[travis-ci-image]: https://travis-ci.org/luqin/echarts.svg
[travis-ci-url]: https://travis-ci.org/luqin/echarts
